Index: uspace/lib/net/tl/socket_core.c
===================================================================
--- uspace/lib/net/tl/socket_core.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/tl/socket_core.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -68,5 +68,5 @@
 INT_MAP_IMPLEMENT(socket_cores, socket_core_t);
 
-GENERIC_CHAR_MAP_IMPLEMENT(socket_port_map, socket_core_t *);
+GENERIC_CHAR_MAP_IMPLEMENT(socket_port_map, socket_core_ref);
 
 INT_MAP_IMPLEMENT(socket_ports, socket_port_t);
@@ -85,7 +85,7 @@
  */
 static void
-socket_destroy_core(int packet_phone, socket_core_t *socket,
-    socket_cores_t *local_sockets, socket_ports_t *global_sockets,
-    void (* socket_release)(socket_core_t *socket))
+socket_destroy_core(int packet_phone, socket_core_ref socket,
+    socket_cores_ref local_sockets, socket_ports_ref global_sockets,
+    void (* socket_release)(socket_core_ref socket))
 {
 	int packet_id;
@@ -121,7 +121,7 @@
  */
 void
-socket_cores_release(int packet_phone, socket_cores_t *local_sockets,
-    socket_ports_t *global_sockets,
-    void (* socket_release)(socket_core_t *socket))
+socket_cores_release(int packet_phone, socket_cores_ref local_sockets,
+    socket_ports_ref global_sockets,
+    void (* socket_release)(socket_core_ref socket))
 {
 	int index;
@@ -156,12 +156,12 @@
  * @param[in] key	The socket key identifier.
  * @param[in] key_length The socket key length.
- * @return		EOK on success.
- * @return		ENOMEM if there is not enough memory left.
+ * @returns		EOK on success.
+ * @returns		ENOMEM if there is not enough memory left.
  */
 static int
-socket_port_add_core(socket_port_t *socket_port, socket_core_t *socket,
+socket_port_add_core(socket_port_ref socket_port, socket_core_ref socket,
     const char *key, size_t key_length)
 {
-	socket_core_t **socket_ref;
+	socket_core_ref *socket_ref;
 	int rc;
 
@@ -194,14 +194,14 @@
  * @param[in] socket	The socket to be added.
  * @param[in] port	The port number to be bound to.
- * @return		EOK on success.
- * @return		ENOMEM if there is not enough memory left.
- * @return		Other error codes as defined for the
+ * @returns		EOK on success.
+ * @returns		ENOMEM if there is not enough memory left.
+ * @returns		Other error codes as defined for the
  *			 socket_ports_add() function.
  */
 static int
-socket_bind_insert(socket_ports_t *global_sockets, socket_core_t *socket,
+socket_bind_insert(socket_ports_ref global_sockets, socket_core_ref socket,
     int port)
 {
-	socket_port_t *socket_port;
+	socket_port_ref socket_port;
 	int rc;
 
@@ -248,20 +248,20 @@
  * @param[in] free_ports_end The maximum free port.
  * @param[in] last_used_port The last used free port.
- * @return		EOK on success.
- * @return		ENOTSOCK if the socket was not found.
- * @return		EAFNOSUPPORT if the address family is not supported.
- * @return		EADDRINUSE if the port is already in use.
- * @return		Other error codes as defined for the
+ * @returns		EOK on success.
+ * @returns		ENOTSOCK if the socket was not found.
+ * @returns		EAFNOSUPPORT if the address family is not supported.
+ * @returns		EADDRINUSE if the port is already in use.
+ * @returns		Other error codes as defined for the
  *			socket_bind_free_port() function.
- * @return		Other error codes as defined for the
+ * @returns		Other error codes as defined for the
  *			socket_bind_insert() function.
  */
 int
-socket_bind(socket_cores_t *local_sockets, socket_ports_t *global_sockets,
+socket_bind(socket_cores_ref local_sockets, socket_ports_ref global_sockets,
     int socket_id, void *addr, size_t addrlen, int free_ports_start,
     int free_ports_end, int last_used_port)
 {
-	socket_core_t *socket;
-	socket_port_t *socket_port;
+	socket_core_ref socket;
+	socket_port_ref socket_port;
 	struct sockaddr *address;
 	struct sockaddr_in *address_in;
@@ -322,11 +322,11 @@
  * @param[in] free_ports_end The maximum free port.
  * @param[in] last_used_port The last used free port.
- * @return		EOK on success.
- * @return		ENOTCONN if no free port was found.
- * @return		Other error codes as defined for the
+ * @returns		EOK on success.
+ * @returns		ENOTCONN if no free port was found.
+ * @returns		Other error codes as defined for the
  *			socket_bind_insert() function.
  */
 int
-socket_bind_free_port(socket_ports_t *global_sockets, socket_core_t *socket,
+socket_bind_free_port(socket_ports_ref global_sockets, socket_core_ref socket,
     int free_ports_start, int free_ports_end, int last_used_port)
 {
@@ -367,8 +367,8 @@
  *			requested. A negative identifier is requested if set to
  *			false.
- * @return		The new socket identifier.
- * @return		ELIMIT if there is no socket identifier available.
- */
-static int socket_generate_new_id(socket_cores_t *local_sockets, int positive)
+ * @returns		The new socket identifier.
+ * @returns		ELIMIT if there is no socket identifier available.
+ */
+static int socket_generate_new_id(socket_cores_ref local_sockets, int positive)
 {
 	int socket_id;
@@ -410,13 +410,13 @@
  *			chosen if set to zero or negative. A negative identifier
  *			is chosen if set to negative.
- * @return		EOK on success.
- * @return		EINVAL if the socket_id parameter is NULL.
- * @return		ENOMEM if there is not enough memory left.
+ * @returns		EOK on success.
+ * @returns		EINVAL if the socket_id parameter is NULL.
+ * @returns		ENOMEM if there is not enough memory left.
  */
 int
-socket_create(socket_cores_t *local_sockets, int app_phone,
+socket_create(socket_cores_ref local_sockets, int app_phone,
     void *specific_data, int *socket_id)
 {
-	socket_core_t *socket;
+	socket_core_ref socket;
 	int positive;
 	int rc;
@@ -437,5 +437,5 @@
 	}
 	
-	socket = (socket_core_t *) malloc(sizeof(*socket));
+	socket = (socket_core_ref) malloc(sizeof(*socket));
 	if (!socket)
 		return ENOMEM;
@@ -482,13 +482,13 @@
  * @param[in,out] global_sockets The global sockets to be updated.
  * @param[in] socket_release The client release callback function.
- * @return		EOK on success.
- * @return		ENOTSOCK if the socket is not found.
+ * @returns		EOK on success.
+ * @returns		ENOTSOCK if the socket is not found.
  */
 int
-socket_destroy(int packet_phone, int socket_id, socket_cores_t *local_sockets,
-    socket_ports_t *global_sockets,
-    void (*socket_release)(socket_core_t *socket))
-{
-	socket_core_t *socket;
+socket_destroy(int packet_phone, int socket_id, socket_cores_ref local_sockets,
+    socket_ports_ref global_sockets,
+    void (*socket_release)(socket_core_ref socket))
+{
+	socket_core_ref socket;
 	int accepted_id;
 
@@ -516,13 +516,13 @@
  * @param[in] packet	The packet to be transfered.
  * @param[out] length	The total data length.
- * @return		EOK on success.
- * @return		EBADMEM if the length parameter is NULL.
- * @return		ENOMEM if there is not enough memory left.
- * @return		Other error codes as defined for the data_reply()
+ * @returns		EOK on success.
+ * @returns		EBADMEM if the length parameter is NULL.
+ * @returns		ENOMEM if there is not enough memory left.
+ * @returns		Other error codes as defined for the data_reply()
  *			function.
  */
-int socket_reply_packets(packet_t *packet, size_t *length)
-{
-	packet_t *next_packet;
+int socket_reply_packets(packet_t packet, size_t *length)
+{
+	packet_t next_packet;
 	size_t fragments;
 	size_t *lengths;
@@ -598,13 +598,13 @@
  * @param[in] key	The socket key identifier.
  * @param[in] key_length The socket key length.
- * @return		The found socket.
- * @return		NULL if no socket was found.
- */
-socket_core_t *
-socket_port_find(socket_ports_t *global_sockets, int port, const char *key,
+ * @returns		The found socket.
+ * @returns		NULL if no socket was found.
+ */
+socket_core_ref
+socket_port_find(socket_ports_ref global_sockets, int port, const char *key,
     size_t key_length)
 {
-	socket_port_t *socket_port;
-	socket_core_t **socket_ref;
+	socket_port_ref socket_port;
+	socket_core_ref *socket_ref;
 
 	socket_port = socket_ports_find(global_sockets, port);
@@ -628,8 +628,8 @@
  */
 void
-socket_port_release(socket_ports_t *global_sockets, socket_core_t *socket)
-{
-	socket_port_t *socket_port;
-	socket_core_t **socket_ref;
+socket_port_release(socket_ports_ref global_sockets, socket_core_ref socket)
+{
+	socket_port_ref socket_port;
+	socket_core_ref *socket_ref;
 
 	if (!socket->port)
@@ -673,14 +673,14 @@
  * @param[in] key	The socket key identifier.
  * @param[in] key_length The socket key length.
- * @return		EOK on success.
- * @return		ENOENT if the port is not already used.
- * @return		Other error codes as defined for the
+ * @returns		EOK on success.
+ * @returns		ENOENT if the port is not already used.
+ * @returns		Other error codes as defined for the
  *			socket_port_add_core() function.
  */
 int
-socket_port_add(socket_ports_t *global_sockets, int port,
-    socket_core_t *socket, const char *key, size_t key_length)
-{
-	socket_port_t *socket_port;
+socket_port_add(socket_ports_ref global_sockets, int port,
+    socket_core_ref socket, const char *key, size_t key_length)
+{
+	socket_port_ref socket_port;
 	int rc;
 
Index: uspace/lib/net/tl/tl_common.c
===================================================================
--- uspace/lib/net/tl/tl_common.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/tl/tl_common.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -64,8 +64,8 @@
  * @param[in] addrlen	The address length.
  * @param[out] port	The set port.
- * @return		EOK on success.
- * @return		EINVAL if the address length does not match the address
+ * @returns		EOK on success.
+ * @returns		EINVAL if the address length does not match the address
  *			family.
- * @return		EAFNOSUPPORT if the address family is not supported.
+ * @returns		EAFNOSUPPORT if the address family is not supported.
  */
 int
@@ -120,6 +120,6 @@
 int
 tl_get_ip_packet_dimension(int ip_phone,
-    packet_dimensions_t *packet_dimensions, device_id_t device_id,
-    packet_dimension_t **packet_dimension)
+    packet_dimensions_ref packet_dimensions, device_id_t device_id,
+    packet_dimension_ref *packet_dimension)
 {
 	int rc;
@@ -158,12 +158,12 @@
  * @param[in] device_id	The device identifier.
  * @param[in] content	The new maximum content size.
- * @return		EOK on success.
+ * @returns		EOK on success.
  * @return		ENOENT if the packet dimension is not cached.
  */
 int
-tl_update_ip_packet_dimension(packet_dimensions_t *packet_dimensions,
+tl_update_ip_packet_dimension(packet_dimensions_ref packet_dimensions,
     device_id_t device_id, size_t content)
 {
-	packet_dimension_t *packet_dimension;
+	packet_dimension_ref packet_dimension;
 
 	packet_dimension = packet_dimensions_find(packet_dimensions, device_id);
@@ -196,8 +196,8 @@
  * @param[in] addrlen	The address length.
  * @param[in] port	The port to be set.
- * @return		EOK on success.
- * @return		EINVAL if the address length does not match the address
+ * @returns		EOK on success.
+ * @returns		EINVAL if the address length does not match the address
  *			family.
- * @return		EAFNOSUPPORT if the address family is not supported.
+ * @returns		EAFNOSUPPORT if the address family is not supported.
  */
 int tl_set_address_port(struct sockaddr * addr, int addrlen, uint16_t port)
@@ -244,12 +244,12 @@
  * @param[in] error	The packet error reporting service. Prefixes the
  *			received packet.
- * @return		EOK on success.
- * @return		ENOENT if no packet may be sent.
- */
-int
-tl_prepare_icmp_packet(int packet_phone, int icmp_phone, packet_t *packet,
+ * @returns		EOK on success.
+ * @returns		ENOENT if no packet may be sent.
+ */
+int
+tl_prepare_icmp_packet(int packet_phone, int icmp_phone, packet_t packet,
     services_t error)
 {
-	packet_t *next;
+	packet_t next;
 	uint8_t *src;
 	int length;
@@ -280,13 +280,13 @@
  * @param[in] addr	The destination address.
  * @param[in] addrlen	The address length.
- * @return		Number of bytes received.
- * @return		EINVAL if the client does not send data.
- * @return		ENOMEM if there is not enough memory left.
- * @return		Other error codes as defined for the
+ * @returns		Number of bytes received.
+ * @returns		EINVAL if the client does not send data.
+ * @returns		ENOMEM if there is not enough memory left.
+ * @returns		Other error codes as defined for the
  *			async_data_read_finalize() function.
  */
 int
-tl_socket_read_packet_data(int packet_phone, packet_t **packet, size_t prefix,
-    const packet_dimension_t *dimension, const struct sockaddr *addr,
+tl_socket_read_packet_data(int packet_phone, packet_ref packet, size_t prefix,
+    const packet_dimension_ref dimension, const struct sockaddr *addr,
     socklen_t addrlen)
 {
Index: uspace/lib/net/tl/tl_interface.c
===================================================================
--- uspace/lib/net/tl/tl_interface.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/net/tl/tl_interface.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -58,5 +58,5 @@
  */
 int
-tl_received_msg(int tl_phone, device_id_t device_id, packet_t *packet,
+tl_received_msg(int tl_phone, device_id_t device_id, packet_t packet,
     services_t target, services_t error)
 {
Index: uspace/lib/packet/generic/packet_server.c
===================================================================
--- uspace/lib/packet/generic/packet_server.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/packet/generic/packet_server.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -36,4 +36,5 @@
 
 #include <packet_server.h>
+#include <packet_local.h>
 
 #include <align.h>
@@ -68,5 +69,5 @@
 	fibril_mutex_t lock;
 	/** Free packet queues. */
-	packet_t *free[FREE_QUEUES_COUNT];
+	packet_t free[FREE_QUEUES_COUNT];
 	
 	/**
@@ -102,4 +103,13 @@
 };
 
+int packet_translate_local(int phone, packet_ref packet, packet_id_t packet_id)
+{
+	if (!packet)
+		return EINVAL;
+	
+	*packet = pm_find(packet_id);
+	return (*packet) ? EOK : ENOENT;
+}
+
 /** Clears and initializes the packet according to the given dimensions.
  *
@@ -112,10 +122,10 @@
  */
 static void
-packet_init(packet_t *packet, size_t addr_len, size_t max_prefix,
+packet_init(packet_t packet, size_t addr_len, size_t max_prefix,
     size_t max_content, size_t max_suffix)
 {
 	// clear the packet content
-	bzero(((void *) packet) + sizeof(packet_t),
-	    packet->length - sizeof(packet_t));
+	bzero(((void *) packet) + sizeof(struct packet),
+	    packet->length - sizeof(struct packet));
 	
 	// clear the packet header
@@ -125,5 +135,5 @@
 	packet->next = 0;
 	packet->addr_len = 0;
-	packet->src_addr = sizeof(packet_t);
+	packet->src_addr = sizeof(struct packet);
 	packet->dest_addr = packet->src_addr + addr_len;
 	packet->max_prefix = max_prefix;
@@ -144,16 +154,16 @@
  * @param[in] max_content The maximal content length in bytes.
  * @param[in] max_suffix The maximal suffix length in bytes.
- * @return		The packet of dimensions at least as given.
- * @return		NULL if there is not enough memory left.
- */
-static packet_t *
+ * @returns		The packet of dimensions at least as given.
+ * @returns		NULL if there is not enough memory left.
+ */
+static packet_t
 packet_create(size_t length, size_t addr_len, size_t max_prefix,
     size_t max_content, size_t max_suffix)
 {
-	packet_t *packet;
+	packet_t packet;
 	int rc;
 
 	// already locked
-	packet = (packet_t *) mmap(NULL, length, PROTO_READ | PROTO_WRITE,
+	packet = (packet_t) mmap(NULL, length, PROTO_READ | PROTO_WRITE,
 	    MAP_SHARED | MAP_ANONYMOUS, 0, 0);
 	if (packet == MAP_FAILED)
@@ -188,14 +198,14 @@
  * @return		NULL if there is not enough memory left.
  */
-static packet_t *
+static packet_t
 packet_get_local(size_t addr_len, size_t max_prefix, size_t max_content,
     size_t max_suffix)
 {
-	size_t length = ALIGN_UP(sizeof(packet_t) + 2 * addr_len +
+	size_t length = ALIGN_UP(sizeof(struct packet) + 2 * addr_len +
 	    max_prefix + max_content + max_suffix, PAGE_SIZE);
 	
 	fibril_mutex_lock(&ps_globals.lock);
 	
-	packet_t *packet;
+	packet_t packet;
 	unsigned int index;
 	
@@ -231,4 +241,16 @@
 }
 
+packet_t packet_get_4_local(int phone, size_t max_content, size_t addr_len,
+    size_t max_prefix, size_t max_suffix)
+{
+	return packet_get_local(addr_len, max_prefix, max_content, max_suffix);
+}
+
+packet_t packet_get_1_local(int phone, size_t content)
+{
+	return packet_get_local(DEFAULT_ADDR_LEN, DEFAULT_PREFIX, content,
+	    DEFAULT_SUFFIX);
+}
+
 /** Release the packet and returns it to the appropriate free packet queue.
  *
@@ -238,5 +260,5 @@
  *
  */
-static void packet_release(packet_t *packet)
+static void packet_release(packet_t packet)
 {
 	int index;
@@ -256,10 +278,10 @@
  *
  * @param[in] packet_id	The first packet identifier.
- * @return		EOK on success.
- * @return		ENOENT if there is no such packet.
+ * @returns		EOK on success.
+ * @returns		ENOENT if there is no such packet.
  */
 static int packet_release_wrapper(packet_id_t packet_id)
 {
-	packet_t *packet;
+	packet_t packet;
 
 	packet = pm_find(packet_id);
@@ -274,14 +296,19 @@
 }
 
+void pq_release_local(int phone, packet_id_t packet_id)
+{
+	(void) packet_release_wrapper(packet_id);
+}
+
 /** Shares the packet memory block.
  * @param[in] packet	The packet to be shared.
- * @return		EOK on success.
- * @return		EINVAL if the packet is not valid.
- * @return		EINVAL if the calling module does not accept the memory.
- * @return		ENOMEM if the desired and actual sizes differ.
- * @return		Other error codes as defined for the
+ * @returns		EOK on success.
+ * @returns		EINVAL if the packet is not valid.
+ * @returns		EINVAL if the calling module does not accept the memory.
+ * @returns		ENOMEM if the desired and actual sizes differ.
+ * @returns		Other error codes as defined for the
  *			async_share_in_finalize() function.
  */
-static int packet_reply(packet_t *packet)
+static int packet_reply(const packet_t packet)
 {
 	ipc_callid_t callid;
@@ -312,10 +339,10 @@
  * @param[out] answer_count The last parameter for the actual answer in the
  *			answer parameter.
- * @return		EOK on success.
- * @return		ENOMEM if there is not enough memory left.
- * @return		ENOENT if there is no such packet as in the packet
+ * @returns		EOK on success.
+ * @returns		ENOMEM if there is not enough memory left.
+ * @returns		ENOENT if there is no such packet as in the packet
  *			message parameter.
- * @return		ENOTSUP if the message is not known.
- * @return		Other error codes as defined for the
+ * @returns		ENOTSUP if the message is not known.
+ * @returns		Other error codes as defined for the
  *			packet_release_wrapper() function.
  */
@@ -324,5 +351,5 @@
     int *answer_count)
 {
-	packet_t *packet;
+	packet_t packet;
 
 	*answer_count = 0;
Index: uspace/lib/packet/include/packet_local.h
===================================================================
--- uspace/lib/packet/include/packet_local.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
+++ uspace/lib/packet/include/packet_local.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -0,0 +1,55 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libpacket
+ * @{
+ */
+
+/** @file
+ */
+
+#ifndef LIBPACKET_PACKET_LOCAL_H_
+#define LIBPACKET_PACKET_LOCAL_H_
+
+#include <net/packet.h>
+
+/** @name Packet local interface
+ */
+/*@{*/
+
+extern int packet_translate_local(int, packet_ref, packet_id_t);
+extern packet_t packet_get_4_local(int, size_t, size_t, size_t, size_t);
+extern packet_t packet_get_1_local(int, size_t);
+extern void pq_release_local(int, packet_id_t);
+
+/*@}*/
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/usb/src/hcdhubd.c
===================================================================
--- uspace/lib/usb/src/hcdhubd.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/lib/usb/src/hcdhubd.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -305,5 +305,5 @@
 	hc->transfer_ops->transfer_out(hc, &dev, &endpoint, buffer, size, NULL, NULL);
 
-	*handle = (usb_handle_t)NULL;
+	*handle = NULL;
 
 	return EOK;
Index: uspace/srv/hid/kbd/genarch/gsp.c
===================================================================
--- uspace/srv/hid/kbd/genarch/gsp.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/srv/hid/kbd/genarch/gsp.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -198,6 +198,6 @@
 	if (t == NULL) {
 		printf("gsp_step: not found\n");
-		*mods = 0;
-		*key = 0;
+		*mods = NULL;
+		*key = NULL;
 		return 0;
 	}
Index: uspace/srv/hw/netif/dp8390/dp8390.c
===================================================================
--- uspace/srv/hw/netif/dp8390/dp8390.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/srv/hw/netif/dp8390/dp8390.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -62,8 +62,8 @@
  *  @param[in] dep The network interface structure.
  *  @param[in] packet The outgoing packet.
- *  @return EOK on success.
- *  @return EINVAL 
+ *  @returns EOK on success.
+ *  @returns EINVAL 
  */
-int queue_packet(dpeth_t * dep, packet_t *packet);
+int queue_packet(dpeth_t * dep, packet_t packet);
 
 /** Reads a memory block byte by byte.
@@ -336,6 +336,6 @@
 }
 
-int queue_packet(dpeth_t * dep, packet_t *packet){
-	packet_t *tmp;
+int queue_packet(dpeth_t * dep, packet_t packet){
+	packet_t tmp;
 
 	if(dep->packet_count >= MAX_PACKETS){
@@ -361,5 +361,5 @@
  *			based on	do_vwrite				     *
  *===========================================================================*/
-int do_pwrite(dpeth_t * dep, packet_t *packet, int from_int)
+int do_pwrite(dpeth_t * dep, packet_t packet, int from_int)
 {
 //	int port, count, size;
@@ -432,5 +432,5 @@
 	dep->de_write_iovec.iod_iovec[0].iov_size = size;
 	dep->de_write_iovec.iod_iovec_s = 1;
-	dep->de_write_iovec.iod_iovec_addr = (uintptr_t) NULL;
+	dep->de_write_iovec.iod_iovec_addr = NULL;
 
 	if (size < ETH_MIN_PACK_SIZE || size > ETH_MAX_PACK_SIZE_TAGGED)
@@ -910,5 +910,5 @@
 dpeth_t *dep;
 {
-	packet_t *packet;
+	packet_t packet;
 
 //	if (!(dep->de_flags &DEF_SEND_AVAIL))
@@ -1003,5 +1003,5 @@
 {
 	int last, count;
-	packet_t *packet;
+	packet_t packet;
 
 //	if (!(dep->de_flags &DEF_READING))
@@ -1015,5 +1015,5 @@
 	dep->de_read_iovec.iod_iovec[0].iov_size = length;
 	dep->de_read_iovec.iod_iovec_s = 1;
-	dep->de_read_iovec.iod_iovec_addr = (uintptr_t) NULL;
+	dep->de_read_iovec.iod_iovec_addr = NULL;
 
 	last = page + (length - 1) / DP_PAGESIZE;
Index: uspace/srv/hw/netif/dp8390/dp8390.h
===================================================================
--- uspace/srv/hw/netif/dp8390/dp8390.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/srv/hw/netif/dp8390/dp8390.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -313,5 +313,5 @@
 	/** Outgoing packets queue.
 	 */
-	packet_t *packet_queue;
+	packet_t packet_queue;
 	/** Outgoing packets count.
 	 */
@@ -320,5 +320,5 @@
 	/** Received packets queue.
 	 */
-	packet_t *received_queue;
+	packet_t received_queue;
 	/** Received packets count.
 	 */
Index: uspace/srv/hw/netif/dp8390/dp8390_drv.h
===================================================================
--- uspace/srv/hw/netif/dp8390/dp8390_drv.h	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/srv/hw/netif/dp8390/dp8390_drv.h	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -72,5 +72,5 @@
  *  @returns 
  */
-int do_pwrite(dpeth_t * dep, packet_t *packet, int from_int);
+int do_pwrite(dpeth_t * dep, packet_t packet, int from_int);
 
 /** Prints out network interface information.
Index: uspace/srv/hw/netif/dp8390/dp8390_module.c
===================================================================
--- uspace/srv/hw/netif/dp8390/dp8390_module.c	(revision 32eceb4ff0c0ddeba47997beaa5d0677aee84d3a)
+++ uspace/srv/hw/netif/dp8390/dp8390_module.c	(revision 1b22bd45ebc7f42217757e90fa6e5b57f6ed5d1d)
@@ -103,5 +103,5 @@
 	netif_device_t * device;
 	dpeth_t * dep;
-	packet_t *received;
+	packet_t received;
 	device_id_t device_id;
 	int phone;
@@ -127,5 +127,5 @@
 		dep->received_count = 0;
 		fibril_rwlock_write_unlock(&netif_globals.lock);
-		nil_received_msg(phone, device_id, received, SERVICE_NONE);
+		nil_received_msg(phone, device_id, received, NULL);
 	}else{
 		fibril_rwlock_write_unlock(&netif_globals.lock);
@@ -157,6 +157,5 @@
 }
 
-int netif_get_device_stats(device_id_t device_id, device_stats_t *stats)
-{
+int netif_get_device_stats(device_id_t device_id, device_stats_ref stats){
 	netif_device_t * device;
 	eth_stat_t * de_stat;
@@ -186,5 +185,5 @@
 }
 
-int netif_get_addr_message(device_id_t device_id, measured_string_t *address){
+int netif_get_addr_message(device_id_t device_id, measured_string_ref address){
 	netif_device_t * device;
 	int rc;
@@ -247,8 +246,8 @@
 }
 
-int netif_send_message(device_id_t device_id, packet_t *packet, services_t sender){
-	netif_device_t * device;
-	dpeth_t * dep;
-	packet_t *next;
+int netif_send_message(device_id_t device_id, packet_t packet, services_t sender){
+	netif_device_t * device;
+	dpeth_t * dep;
+	packet_t next;
 	int rc;
 
